/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.grapeshot.halfnes;

import java.awt.event.*;
import java.util.prefs.Preferences;

/**
 *
 * @author Andrew
 */
public class Controller implements KeyListener {

    private final int keyUp, keyDown, keyLeft, keyRight, keyA, keyB, keySelect, keyStart;
    private int controllerbyte = 0x00;

    public Controller(final Preferences prefs, final int controllernum) {
        switch (controllernum) {
            case 0:
                keyUp = prefs.getInt("keyUp1", KeyEvent.VK_UP);
                keyDown = prefs.getInt("keyDown1", KeyEvent.VK_DOWN);
                keyLeft = prefs.getInt("keyLeft1", KeyEvent.VK_LEFT);
                keyRight = prefs.getInt("keyRight1", KeyEvent.VK_RIGHT);
                keyA = prefs.getInt("keyA1", KeyEvent.VK_X);
                keyB = prefs.getInt("keyB1", KeyEvent.VK_Z);
                keySelect = prefs.getInt("keySelect1", KeyEvent.VK_SHIFT);
                keyStart = prefs.getInt("keyStart1", KeyEvent.VK_ENTER);
                break;
            case 1:
            default:
                keyUp = prefs.getInt("keyUp2", KeyEvent.VK_W);
                keyDown = prefs.getInt("keyDown2", KeyEvent.VK_S);
                keyLeft = prefs.getInt("keyLeft2", KeyEvent.VK_A);
                keyRight = prefs.getInt("keyRight2", KeyEvent.VK_D);
                keyA = prefs.getInt("keyA2", KeyEvent.VK_G);
                keyB = prefs.getInt("keyB2", KeyEvent.VK_F);
                keySelect = prefs.getInt("keySelect2", KeyEvent.VK_R);
                keyStart = prefs.getInt("keyStart2", KeyEvent.VK_T);
                break;
        }
    }

    @Override
    public void keyPressed(final KeyEvent arg0) {
        final int kepressed = arg0.getKeyCode();
        if (kepressed == keyA) {
            // A
            controllerbyte |=  0x01;
        } else if (kepressed == keyB) {
            controllerbyte |=  0x02;
            // B
        } else if (kepressed == keySelect) {
            controllerbyte |=  0x04;
            // Sel
        } else if (kepressed == keyStart) {
            controllerbyte |=  0x08;
            // Start
        } else if (kepressed == keyUp) {
            controllerbyte |=  0x10;
            // Up
            controllerbyte &=  (0xff - 0x20);
            //turn down off when up pressed
        } else if (kepressed == keyDown) {
            controllerbyte |=  0x20;
            // Down
            controllerbyte &=  (0xff - 0x10);
        } else if (kepressed == keyLeft) {
            controllerbyte |=  0x40;
            // Left
            controllerbyte &=  (0xff - 0x80);
        } else if (kepressed == keyRight) {
            controllerbyte |=  0x80;
            // Right
            controllerbyte &=  (0xff - 0x40);
        }
    }

    @Override
    public void keyReleased(final KeyEvent arg0) {
        final int kepressed = arg0.getKeyCode();
        if (kepressed == keyA) {
            // A
            controllerbyte &=  0xFE;
        }
        if (kepressed == keyB) {
            controllerbyte &=  (0xff - 0x02);
            // B
        }
        if (kepressed == keySelect) {
            controllerbyte &=  (0xff - 0x04);
            // Sel
        }
        if (kepressed == keyStart) {
            controllerbyte &=  (0xff - 0x08);
            // Start
        }
        if (kepressed == keyUp) {
            controllerbyte &=  (0xff - 0x10);
            // Up
        }
        if (kepressed == keyDown) {
            controllerbyte &=  (0xff - 0x20);
            // Down
        }
        if (kepressed == keyLeft) {
            controllerbyte &=  (0xff - 0x40);
            // Left
        }
        if (kepressed == keyRight) {
            controllerbyte &=  (0xff - 0x80);
            // Right
        }
    }

    public int getbyte() {
        return controllerbyte;
    }

    @Override
    public void keyTyped(final KeyEvent arg0) {
        // TODO Auto-generated method stub
    }
}
